<?php
/*****************************************************************************
 *
 * pnp_graph.php - Sample HTML based pnp graph gadget for NagVis
 *
 *****************************************************************************/

/**
 * Dummy perfdata for WUI
 *
 * This string needs to be set in every gadget to have some sample data in the
 * WUI to be able to place the gadget easily on the map
 ******************************************************************************/
$sDummyPerfdata = 'config=20%;80;90;0;100';

/**
 * In a perfect world this setting would also tell NagVis that I want to output
 * the gadget as html. At the time of writing this isn't true, the gadget_type
 * still needs to be set. However this variable takes care of any errors that
 * might occur. Let this setting be html and maybe sometime in the future this
 * setting may actually mean output gadget as html as well.
 */
$_MODE = 'html';

// Include the gadgets core. Also handle OMD default and local paths
if(substr($_SERVER["SCRIPT_FILENAME"], 0, 4) == '/omd') {
	$core = dirname($_SERVER["SCRIPT_FILENAME"]) . '/gadgets_core.php';
	if(file_exists($core))
		require($core);
	else
		require(str_replace('local/share/', 'share/', $core));
} else {
	require('./gadgets_core.php');
}

function str_is_num($str='')
{
	# Match a non-decimal number of 0 or greater, but not with leading zeroes.
	return (is_numeric($str) && $str >= 0 && $str == round($str));
}

// Get url components
$host = $aOpts['name1'];
$service =  $aOpts['name2'];

// Get scaling of gadget
$scale = $aOpts['scale'];

$height = NULL;
$width = NULL;
$view = 0;
$source = 0;
if (isset($aOpts['opts']) && ($aOpts['opts'] !== '')) {
	preg_match_all ('/(\w+)=([\w,]+)/',$aOpts['opts'],$matches,PREG_SET_ORDER);
	foreach ($matches as $match) {
		if ($match[1] === 'height' && str_is_num($match[2])) { $height = $match[2]; }
		if ($match[1] === 'source') { $source = $match[2]; }
		if ($match[1] === 'view' && str_is_num($match[2])) { $view = $match[2]; }
		if ($match[1] === 'width' && str_is_num($match[2])) { $width = $match[2]; }
	}
}

// Set pnp path, the image will be rendered by pnp
$pnp_path = "/monitor/op5/pnp/image?view=$view&host=".urlencode($host)."&srv=".urlencode($service);

// Add height and width parameters if defined
if($height !== NULL) { $pnp_path .= "&h=$height"; }
if($width !== NULL) { $pnp_path .= "&w=$width"; }


$pnp_paths = array();
if(str_is_num($source)) {
	$pnp_paths[] = "$pnp_path&source=$source";
} elseif($source === 'all') {
	foreach($aPerfdata as $ds => $values) {
		$pnp_paths[] = "$pnp_path&source=$ds";
	}
} elseif(strpos($source, ',') !== false) {
	$sources = explode(',', $source);
	foreach($sources as $ds) {
		if(str_is_num($ds)) {
			$pnp_paths[] = "$pnp_path&source=$ds";
		}
	}
}

// Print all graphs
foreach($pnp_paths as $path) {
	$id=time();
    $path=$path.'&id='.$id;

	echo "<img src='$path' width='$scale%' height='$scale%'></img><br>";
}
